100 REMark ************************************************************
110 REMark *                                                          *
120 REMark *  Restore a data file into an executable using dataspace  *
130 REMark *  in the matching _qh file.  Needs Toolkit 2 extensions.  *
140 REMark *              Copyright  Dilwyn Jones, 2001              *
150 REMark *                                                          *
160 REMark ************************************************************
170 :
180 CLS : CLS #0
190 :
200 INPUT #0,'Filename of source file      > ';ip$
210 IF ip$ = '' THEN STOP
220 Split ip$ : REMark split to drive$ & filename$
230 :
240 INPUT #0,'Filename of destination file > ';op$
250 IF op$ = '' THEN STOP
260 :
270 REMark construct filename of the matching _qh file
280 qh_filename$ = filename$
290 IF LEN(qh_filename$) > 33 : qh_filename$ = qh_filename$(1 TO 33)
300 qh_filename$ = qh_filename$&'_qh'
310 :
320 REMark try to open the _qh file to get the dataspace value
330 channel = FOP_IN(drive$&qh_filename$)
340 IF channel = -7 THEN
350   REMark Not Found, so try '.qh' filename instead of '_qh'
360   qh_filename$(LEN(qh_filename$)-2) = '.'
370   channel = FOP_IN(drive$&qh_filename$)
380 END IF
390 IF channel < 0 : PRINT #0,'Failed to open ';qh_filename$ : STOP
400 :
410 REMark fetch dataspace value
420 BGET #channel,byte1 : BGET #channel,byte2
430 BGET #channel,byte3 : BGET #channel,byte4
440 CLOSE #channel
450 :
460 REMark calculate dataspace value
470 dspace = (256*256*256*byte1) + (256*256*byte2) + (256*byte3) + (byte4)
480 :
490 REMark try to allocate enough space to hold copy of program
500 fl = FLEN(\ip$) : base = ALCHP(fl)
510 IF base < 0 THEN PRINT #0,'Out of memory.' : STOP : REMark oops
520 :
530 REMark LBYTES program into memory, then SEXEC to turn into a job
540 LBYTES ip$,base           : REMark load original file
550 PRINT #0,'Saving ';op$;'...'
560 SEXEC  op$,base,fl,dspace : REMark save the executable version
570 RECHP  base               : REMark release memory used
580 STOP
590 :
600 DEFine PROCedure Split (n$)
610   LOCal us
620   REMark split drive and file names at first underscore
630   us = '_' INSTR n$
640   IF us = 0 THEN
650     drive$ = n$ : filename$ = ''
660   ELSE
670     drive$ = n$(1 TO us) : filename$ = ''
680     IF us < LEN(n$) THEN filename$ = n$(us+1 TO LEN(n$))
690   END IF
700 END DEFine Split
